#include	<stdio.h>
#include	"defs.h"
#include	"global.h"

/*-->GetBytes*/
/**********************************************************************/
/*****************************  GetBytes  *****************************/
/**********************************************************************/

void
	GetBytes(fp, cp, n)	/* get n bytes from file fp */
register FILE *fp;	/* file pointer	 */
register char *cp;	/* character pointer */
register int n;		/* number of bytes  */
{
	while (n--)
		*cp++ = getc(fp);
}


/*-->NoSignExtend*/
/**********************************************************************/
/***************************  NoSignExtend  ***************************/
/**********************************************************************/

int
	NoSignExtend(fp, n)	/* return n byte quantity from file fd */
register FILE *fp;	/* file pointer    */
register int n;		/* number of bytes */
{
	register int x;	/* number being constructed */
	
	x = 0;
	while (n--) {
		x <<= 8;
		x |= getc(fp);
	}
	return(x);
}


/*-->SignExtend*/
/**********************************************************************/
/****************************  SignExtend  ****************************/
/**********************************************************************/

int
	SignExtend(fp, n)        /* return n byte quantity from file fd */
register FILE *fp;  /* file pointer    */
register int n;     /* number of bytes */
{
	int n1;         /* number of bytes	    */
	register int x; /* number being constructed */
	
	x = getc(fp);   /* get first (high-order) byte */
	n1 = n--;
	while (n--)  {
		x <<= 8;
		x |= getc(fp);
	}
	
	/* NOTE: This code assumes that the right-shift is an arithmetic, rather
	   than logical, shift which will propagate the sign bit right.   According
	   to Kernighan and Ritchie, this is compiler dependent! */
	
	x<<=32-8*n1;
	x>>=32-8*n1;  /* sign extend */
	
#ifdef DEBUG
	if (Debug)
	{
		fprintf(stderr,"\tSignExtend(fp,%d)=%X\n",n1,x);
	}
#endif
	return(x);
}


/* formatted i/o was killing us, so build some tables */
char    *digit = "0123456789ABCDEF";

/*-->PutInt*/
/**********************************************************************/
/*****************************  PutInt  *******************************/
/**********************************************************************/

void
	PutInt(n)               /* output an integer followed by a space */
register int n;
{
	char buf[10];
	register char *b;
	
	if( n == 0 )
		putchar('0'); 
	else {
		if( n < 0 ) {
			putchar('-');
			n = -n;
		}
		for(b=buf;  n>0;  ) {
			*b++ = digit[n%10];
			n /= 10;
		}
		for( ; b>buf; )
			putchar(*--b);
	}
	
	putchar(' ');
}



/*
 *	PutOct
 */
void	PutOct(n)  /* output an 3 digit octal number preceded by a "\" */
register int n;
{                  
    putchar( '\\' ); 
    putchar( digit[(n&0300)>>6] );
    putchar( digit[(n&0070)>>3] ); 
    putchar( digit[n&0007] );
}
